# Charles Andr
# pseudo console
# ShowPseudoConsole: February 6, 2002

global ConsolePrivate

set ConsolePrivate(lMax) 30


set _show(pc) 1
set ww .stderrf
set ConsolePrivate(w) $ww

toplevel $ww
wm title $ww "pseudo console"
wm protocol $ww WM_DELETE_WINDOW {
	    set _show(pc) 0
	    ShowPseudoConsole
	}

set w [frame $ww.f]
pack $w -fill both -expand yes

set ConsolePrivate(txt) [text $w.text -relief sunken -bd 2 -yscrollcommand "$w.scroll set" -setgrid 1 \
	-height 30]
scrollbar $w.scroll -command "$w.text yview"
pack $w.scroll -side right -fill y
pack $w.text -expand yes -fill both
$w.text insert 1.0 "\[1\] Pseudo-Console" 
set ConsolePrivate(youngest) 1
set ConsolePrivate(oldest) 1

 
set qh [button $w.q -text "Hide" -command {set _show(pc) 0; ShowPseudoConsole}]
pack $qh   
    
proc putsStderr { args } {
	global ConsolePrivate
	
	set w $ConsolePrivate(w)
	set t $ConsolePrivate(txt)
	set y $ConsolePrivate(youngest)
	set o $ConsolePrivate(oldest)
	set ny [expr $y + 1]
	set ConsolePrivate(youngest) $ny

	switch -- [wm state $w] {
	    normal {
		# Raise a buried window
		raise $w
	    }
	    withdrawn -
	    iconified {
		# Open and restore geometry
		wm deiconify $w
	    }
	}
		
		
	if [expr $y > $ConsolePrivate(lMax) ] {
	   set no [expr $o + 1]
	   $t delete 1.0 2.0
	   set ConsolePrivate(oldest) $no
	}
	$t insert end "\n\[$ny\] "
	uplevel #0 $t insert end $args	

}


proc errorReport { msg } {

    putsStderr "****** Error: $msg\nAbort"
    tk_dialog .wmsg Error $msg error 0 OK
    exit
}

proc warningReport { msg } {

    putsStderr "****** Warning: $msg\n"
    tk_dialog .wmsg Warning $msg warning 0 OK
 
}

proc internalErrorReport { msg } {
	set newMsg "******Internal Error.\n Please report to andre@unice.fr\n: $msg\n"
	 putsStderr $newMsg
    tk_dialog .wmsg Error $newMsg error 0 OK
    exit
}


###############################################
	
proc ShowPseudoConsole {} {
	global _show
	# _show(pc) == 1 : show
	# _show(pc) == 0 : hide
	# the toplevel window is .stderrf
	
	set s [wm state .stderrf]
	# putsStderr "ShowPseudoConsole $_show(pc) ($s)"
	if $_show(pc) {
		switch $s {
			normal {
				raise .stderrf
			}
			iconic {
				wm deiconify .stderrf
			}
			withdrawn {
				wm deiconify .stderrf
			}
		}
	} else {
		wm withdraw .stderrf
	}			
}
	
putsStderr "pseudoCon.tcl sourced!"